<script setup>
</script>

<script>
import jQuery from "jquery";
import Jszip from 'jszip';
import DataTable from 'datatables.net-vue3';
import DataTableLib from 'datatables.net-bs5';
import 'datatables.net-buttons-bs5';
import 'datatables.net-buttons/js/buttons.html5.mjs';
import DataTableResponsive from "datatables.net-bs5";
import axios from 'axios';
import $ from 'jquery';
import swal from 'sweetalert';
import Multiselect from '@vueform/multiselect'
import '@vueform/multiselect/themes/default.css'
import { inject } from 'vue';

// Configurar JSZip
window.JSZip = Jszip;

// Inicializar DataTables con las bibliotecas
DataTable.use(DataTableLib);
DataTable.use(DataTableResponsive);

document.addEventListener("DOMContentLoaded", function () {
  // Obtener la tabla DataTable
  const dataTable = $('#datatable').DataTable();

  // Agregar un evento de clic a los elementos con la clase "eliminar" dentro de la tabla
  dataTable.on("click", ".eliminar", function (id) {
    const rowData = dataTable.row($(this).closest("tr")).data();
    if (rowData) {
      const id = rowData.id; // Asumiendo que el ID se encuentra en la propiedad 'id'

      swal({
        title: "¿Seguro deseas eliminar?",
        text: "Una vez eliminado no se podra volver a recuperar",
        icon: "warning",
        buttons: true,
        dangerMode: true,
        buttons: ["Cancelar", "Eliminar"],
        confirmButtonClass: "btn-warning",
        cancelButtonClass: "btn-danger"
      })
        .then((willDelete) => {
          if (willDelete) {
            axios.delete('/sanciones/'+ id )
              .then(response => {
                console.log(response);
                swal("Ha sido eliminado exitosamente", {
                  icon: "success",
                  buttons: false
                });
                setTimeout(function () {
                  location.reload();
                }, 1000);
              })
              .catch(error => {
                console.error(error);
                swal("Cancelado", {
                  icon: "error"
                });
              });
          } else {
            console.log('Salvado')
            swal("Cancelado", {
              icon: "error"
            });
          }
        });
    }
  });

  dataTable.on("click", ".detalles", function (id) {
    const rowData = dataTable.row($(this).closest("tr")).data();
    if (rowData) {
      const id = rowData.id;
      window.location.href = '/sanciones/' + id;
      console.log(id);
    }
  });


});

export default {
  components: { DataTable, Multiselect },

  setup(props) {
	  const csrf = inject('csrf');
	  return {
	    csrf,
	  };
	},
  
  data() {
    return {
      products: null,
      fechaInicial:'',
      fechaFinal: '',
      rango:'',
      sancionesIds: '',
      InstitucionesIds:'',
      faltaIds:'',
      responsableSancionIds:'',
      rfc:'',
      admin:this.variables.sancionesDelete,

      TipoFalta: [],
	      Faltas:this.variables && this.variables.tiposFalta
	      ? this.variables.tiposFalta.map(item => item)
	      : [],

        ResponsableSancion: null,
	      Responsables:this.variables && this.variables.responsablesSancion
	      ? this.variables.responsablesSancion.map(item => item)
	      : [],
      


      InstitucionSancionadora: [],
	      OpcionesInstituciones: this.variables && this.variables.institucionesDependencias
	      ? this.variables.institucionesDependencias.map(item => item)
	      : [],

        TiposSancion: [],
	      Sanciones: this.variables && this.variables.tiposSancion
	      ? this.variables.tiposSancion.map(item => item)
	      : [],
        TiposSancionSeleccionados: [],
      columns: [
        { data: null, render: function (data, type, row, meta) { return `${meta.row + 1}` } },
        { data: 'expediente' },
        { data: 'sancionado.nombreRazonSocial' },
        { data: 'institucionDependencia.nombre' },
        { data: 'tiposSancion[].valor' },
        { data: 'resolucion.fechaNotificacion' },
        {
  data: null,
  render: (data, type, row) => {
    if (this.admin == true) {
      return '<a title="Detalles" href="#a" v-on:click="detalles(id)" class="detalles text-warning"><i class=" mdi mdi-eye font-size-18"></i></a> <a href="#a" id="billy" class="eliminar text-danger" title="Eliminar"><i class="mdi mdi-delete font-size-20"></i></a>';
    } else {
      return '<a title="Detalles" href="#a" v-on:click="detalles(id)" class="detalles text-warning"><i class=" mdi mdi-eye font-size-18"></i></a>';
    }
  }
}
      ],
      botones: [
        {
          title: 'Reporte de sanciones a particulares',
          extend: 'excelHtml5',
          text: '<i class ="far fa-file-excel"></i> Descargar Excel',
          className: 'btn btn-success',
          exportOptions: {
        columns: [1,2, 3, 4, 5] // Índices de las columnas a exportar (ajusta esto según tus necesidades)
    }
        }
      ]
    }
  },

  mounted() {
    const dataTable = $('#datatable').DataTable();
    this.getProducts();
  },

  props: {
	    variables: Object,
	},

  watch: {
	 
   TiposSancionSeleccionados: function(newValue) {
     
   // Obtener los IDs de las opciones seleccionadas
   const selectedIds = newValue.map(option => {
     const selectedOption = this.Sanciones.find(sancion => sancion.valor === option);
     return selectedOption ? selectedOption.id : null;
   });


   const selectedNombres = newValue.map(option => {
   const selectedOption = this.Sanciones.find(sancion => sancion.valor === option);
   return selectedOption ? selectedOption.valor : null;
   });

 
   this.sancionesNombre = selectedNombres
   this.sancionesIds = selectedIds;

   console.log(this.sancionesNombre);
   console.log(this.sancionesIds);
 
 },

 TipoFalta: function(newValue) {
     
     // Obtener los IDs de las opciones seleccionadas
     const selectedIds = newValue.map(option => {
       const selectedOption = this.Faltas.find(falta => falta.valor === option);
       return selectedOption ? selectedOption.id : null;
     });
 
 
     const selectedNombres = newValue.map(option => {
     const selectedOption = this.Faltas.find(falta => falta.valor === option);
     return selectedOption ? selectedOption.valor : null;
     });
 
   
     this.sancionesNombre = selectedNombres
     this.faltaIds = selectedIds;
 
     console.log(this.sancionesNombre);
     console.log(this.faltaIds);
   
   },

   InstitucionSancionadora: function(newValue) {
     
     // Obtener los IDs de las opciones seleccionadas
     const selectedIds = newValue.map(option => {
       const selectedOption = this.OpcionesInstituciones.find(institucion => institucion.nombre === option);
       return selectedOption ? selectedOption.id : null;
     });
 
 
     const selectedNombres = newValue.map(option => {
     const selectedOption = this.OpcionesInstituciones.find(institucion => institucion.nombre === option);
     return selectedOption ? selectedOption.nombre : null;
     });
 
   
     this.sancionesNombre = selectedNombres
     this.InstitucionesIds = selectedIds;
 
     console.log(this.sancionesNombre);
     console.log(this.InstitucionesIds);
   
   },

   ResponsableSancion: function(newValue) {
     
     // Obtener los IDs de las opciones seleccionadas
     const selectedIds = newValue.map(option => {
       const selectedOption = this.Responsables.find(responsable => responsable.nombreCompleto === option);
       return selectedOption ? selectedOption.id : null;
     });
 
 
     const selectedNombres = newValue.map(option => {
     const selectedOption = this.Responsables.find(responsable => responsable.nombreCompleto === option);
     return selectedOption ? selectedOption.nombreCompleto : null;
     });
 
   
     this.sancionesNombre = selectedNombres
     this.responsableSancionIds = selectedIds;
 
     console.log(this.sancionesNombre);
     console.log(this.responsableSancionIds);
   
   },

 },

  methods: {
    getProducts() {
      swal({
    icon: 'info',
    text: 'Cargando registros...',
    buttons: false,
    closeOnClickOutside: false,
    closeOnEsc: false,
  });
  axios.get(route('particulares.get.all.sancionados')).then(
        response => {
          swal.close()
          this.products = response.data
        }
      )
    },
    filtroBusqueda() {

      swal({
    icon: 'info',
    text: 'Cargando registros...',
    buttons: false,
    closeOnClickOutside: false,
    closeOnEsc: false,
  });

  axios.get(route('particulares.get.all.sancionados', {rfc:this.rfc,institucionesIds:this.InstitucionesIds,tiposFaltaIds:this.faltaIds,responsablesSancionIds:this.responsableSancionIds,tiposSancionIds:this.sancionesIds,fechaInicial:this.fechaInicial,fechaFinal:this.fechaFinal,rango:this.rango}))
   .then(response => {
    console.log(response.data)
     this.products = response.data
    swal.close();




   })
   .catch(error => {

    console.log(error)

     
   

    swal("Error en el filtrado", {
             icon: "error"
           });
   });
 
},
  generate: function (event) {
      window.location.href = '/sanciones/generate/particulares';
    }
  },


}
</script>

<template>
  <div class="row">
    <div class="col-lg-12">
      <div class="card">
        <div class="card-body">
          <div class="d-grid gap-2 d-md-flex justify-content-md-end dropdown float-end">
            <!-- Formulario para borrar sanciones -->
            <form method="GET" :action="route('sanciones.destroy.all')">
                <div class="input-group">
                    <input type="hidden" name="_token" :value="csrf"/>
                    <button class="btn btn-danger" type="submit" id="buscarDocumento">Borrar Sanciones</button>
                </div> 
            </form>

            <!-- Formulario para generar sanciones -->
            <form :action="route('sanciones.generate.particulares')" method="post" enctype="multipart/form-data">
                <div class="input-group">
                    <input class="form-control" type="file" name="file" accept=".zip">
                    <input type="hidden" name="_token" :value="csrf"/>
                    <button class="btn btn-primary" type="submit">Importar Sanciones</button>
                </div> 
            </form>
          </div>

          <div class="modal fade bs-example-modal-xl" style="margin-left: 100px;" tabindex="-1" role="dialog" aria-labelledby="myExtraLargeModalLabel" aria-hidden="true">
            <div class="modal-dialog modal-xl">
              <div class="modal-content">
                                  <div class="modal-header">
                                      <h5 class="modal-title">Filtros de busqueda</h5>
                                  </div>
                                  <div class="modal-body">
                                    <div class="row">
                                      <div class="col-md-3">
                                        <div class="mb-3">
                                          <label for="validationCustom03" class="form-label">RFC</label>
                                          <div class="input-group">
                                            <input name="" type="text" class="form-control" id="validationCustom03" placeholder="RFC" v-model="rfc"/>
                                            </div> 
                                          </div>
                                      </div>


                                      <div class="col-md-3">
                                        <div class="mb-3">
                                          <label class="form-label">Fecha Inicial</label>
                                          <input type="date" v-model="fechaInicial" class="form-control" placeholder="Ingrese la fecha">
                                        </div>
                                      </div>
                                      <div class="col-md-3">
                                        <div class="mb-3">
                                          <label class="form-label">Fecha Final</label>
                                          <input type="date" v-model="fechaFinal" class="form-control" placeholder="Ingrese la fecha">
                                        </div>
                                      </div>

                                      <div class="col-md-3">
                                        <div class="mb-3">
                                          <label class="form-label">Rango de busqueda</label>
                                          <select class="form-select" v-model="rango" placeholder="Selecciona un rango">
                                            <option>Todos</option>
                                            <option>Este mes</option>
                                            <option>Ultimos 6 meses</option>
                                            <option>Este año</option>
                                          </select> 
                                        </div>
                                      </div>
                                      <div class="col-md-20">
                                        <div class="mb-3">
                                          <label for="validationCustom14" class="form-label">Instituciones Sancionadoras</label>
                                          <Multiselect
                                            v-model="InstitucionSancionadora"
                                            mode="tags"
                                            :close-on-select="false"
                                            :searchable="true"
                                            placeholder="Seleccione una opción"
                                            :options="OpcionesInstituciones.map(option => option.nombre)"
                                            class="tipoSancion"
                                            :max="3"
                                          />
                  
                                            <input type="text" hidden name="tiposSancion" v-model="InstitucionesIds">                                                                               
                                        
                                        </div>
                                      </div>

                                      <div class="col-md-20">
                                        <div class="mb-3">
                                          <label for="validationCustom14" class="form-label">Tipos de faltas</label>
                                          <Multiselect
                                            v-model="TipoFalta"
                                            mode="tags"
                                            :close-on-select="false"
                                            :searchable="true"
                                            placeholder="Seleccione una opción"
                                            :options="Faltas.map(option => option.valor)"
                                            class="tipoSancion"
                                            :max="3"
                                          />
                  
                                            <input type="text" hidden name="tiposSancion" v-model="faltaIds">                                                                                
                                        
                                        </div>
                                      </div>
                                    </div>

                                  

                                    <div class="row">
                                      <div class="col-md-20">
                                        <div class="mb-3">
                                          <label for="validationCustom14" class="form-label">Tipos de Sanción</label>
                                          <Multiselect
                                            v-model="TiposSancionSeleccionados"
                                            mode="tags"
                                            :close-on-select="false"
                                            :searchable="true"
                                            placeholder="Seleccione una opción"
                                            :options="Sanciones.map(option => option.valor)"
                                            class="tipoSancion"
                                            
                                          />
                  
                                          <input type="text" hidden name="tiposSancion" v-model="sancionesIds">                                                                               
                                        
                                        </div>
                                      </div>
                                    </div>

                                    <div class="row">
                                      <div class="col-md-20">
                                        <div class="mb-3">
                                          <label for="validationCustom14" class="form-label">Responsables de sanción</label>
                                          <Multiselect
                                            v-model="ResponsableSancion"
                                            mode="tags"
                                            :close-on-select="false"
                                            :searchable="true"
                                            placeholder="Seleccione una opción"
                                            :options="Responsables.map(option => option.nombreCompleto )"
                                            class="tipoSancion"
                                            :max="3"
                                          />
                  
                                            <input type="text" hidden name="tiposSancion" v-model="responsableSancionIds">                                                                                
                                        
                                        </div>
                                      </div>
                                    </div>

                                    <div class="d-grid gap-2 d-md-flex justify-content-md-end">
                                      <button class="btn btn-danger" data-bs-dismiss="modal" aria-label="Close" type="button">Cancelar</button>
                                      <button class="btn btn-primary" data-bs-dismiss="modal" aria-label="Close" @click="filtroBusqueda"  type="submit">Buscar</button>
                                    </div>

                                    

                                  </div>
                              </div>
                          </div>
                      </div>



          <h4 class="card-title mb-4">Lista de sanciones a particulares</h4>
          <div class="table-responsive">
            <DataTable :data="products" :columns="columns" id="datatable" class=" table-condensed table table-bordered dt-responsive  nowrap w-100"
              :options="{responsive:true,autoWidth:false, dom:'Bfrtip',language:{
                search: 'Buscar', zeroRecords:'No hay registros para mostrar',
                info:'Mostrando del _START_ a _END_ de _TOTAL_ registros',
                infoFiltered: '(Filtrados de _MAX_ registros.)',
                paginate:{first: 'Primero',previous:'Anterior',next:'Siguiente', last:'Último'}
              }, buttons:botones}">
              <thead class="table-light">
                <tr>
                  <th style="width: 1%;">
                  </th>
                  <th class="align-middle text-center" style="width: 10%;">Numero de expediente</th>
                  <th class="align-middle text-center" style="width: 10%;">Nombre</th>
                  <th class="align-middle text-center" style="width: 28%;">Ente</th>
                  <th class="align-middle text-center" style="width: 24%;">Tipo de sanción</th>
                  <th class="align-middle text-center" style="width: 13%;">Fecha</th>
                  <th class="align-middle text-center" style="width: 5%;">Acciones</th>
                </tr>
              </thead>
              <tbody style="text-align: center; font-size: 15px;"></tbody>
            </DataTable>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<style>
.dataTables_wrapper .dataTables_filter {
  margin-right: 10px;
}

.dataTables_filter{
  display: none;
}

#datatable{
  margin-top: 10px;
}


.dt-buttons btn-group {
  background-color: red;
}

@media (min-width: 768px) {
  #TablaPrincipal_wrapper {}
}
</style>